=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

CFLAGS = -Wall -g

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
endif

configure: configure-stamp
configure-stamp:
	dh_testdir
	# Add here commands to configure the package.
	touch configure-stamp

build: build-stamp

build-stamp: configure-stamp 
	dh_testdir
	export PATH=$(PATH):/usr/local/bin
	echo $(PATH)
	scons Prefix=/usr PLTPrefix=/usr STATIC_MODULES=1
	touch build-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f config.log
	rm -f build-stamp configure-stamp
	# Add here commands to clean up after the build process.
	scons -c Prefix=/usr PLTPrefix=/usr STATIC_MODULES=1
	rm -rf .sconf_temp/
	rm -f .sconsign src/.sconsign libfluxus/src/.sconsign libfluxphysics/src/.sconsign
	rm -f .sconsign.dblite
	if test -d patches && quilt applied ; then quilt pop -a ; rm -rf .pc ; fi
	rm -f patches patch-stamp
	dh_clean 

install: build
	dh_testdir
	dh_testroot
	dh_clean -k 
	dh_installdirs

	# Add here commands to install the package into debian/fluxus.
	scons Prefix=/usr PLTPrefix=/usr DESTDIR=debian/fluxus STATIC_MODULES=1 install

# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs CHANGES
	dh_installdocs
	dh_installexamples
	dh_installmenu
	dh_installman
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure
